#!/usr/bin/php -q
<?php
/*

Copyright  2001, 2002, 2003, 2004 Andres Baravalle

This file is part of phpGrabComics.

phpGrabComics is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

phpGrabComics is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpGrabComics; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

// command line comic grabbing utility
// will work under different systems, but requires PHP installed. 
// the file is indipendent and can be moved (or linked, in *nix)

// change the URL with your phpgrabcomics home
$url = "http://www.baravalle.it/phpGrabComics/";
$localhost_url = "http://localhost/phpGrabComics/";

// leave empty if:
// -in the file config.inc in the server:
// 	-you did not setup a password or
// 	-$authenticated = False
// - you are providing authentication through command line
$psw = "";
$user = "";
$buffer = "";

// exit codes are not fully implemented.
// 0: everything is right.

if(!isset($argv) or sizeof($argv)<=1)
{
	echo "getcomics: try getcomics --h for more information\n";
	die(0);
}
else
{
	// prints version
	if(array_search("-v", $argv) or array_search("--v", $argv) or array_search("--version", $argv))
	{
		echo "\ngetcomics 1.3, Copyright 2003, 2004 Andres Baravalle\n";
		echo "getcomics is part of GNU phpGrabComics. GNU phpGrabComics is free software available under the therms of GNU General Public License.\n";
	}
	
	// prints help
	if(array_search("-h", $argv) or array_search("--h", $argv) or array_search("-?", $argv) or array_search("--help", $argv))
	{
		$help = "";
		$help .= "\nUsage:\tgetcomics [options]\n";
		$help .= "\nExample getcomics commands:\n";
		$help .= "  List available comics:        getcomics -l\n";
		$help .= "  Grab strip to standar output: getcomics -c dilbert\n";
		$help .= "  Grab strip using custom site: getcomics -c dilbert -u http://myurl/\n";
		$help .= "  Grab strip to file:           getcomics -c userfriendly -f userfriendly.gif\n";
		$help .= "  Update comics:                getcomics -l login -p password -u http://yoururl/phpgrabcomics.xml -g\n";
		$help .= "\nOptions:\n";
		$help .= "  -c <string>\tGrab comic and return to standard output\n";
		$help .= "  -f <string>\tSave grabbed comic to destination\n";
		$help .= "  -F         \tSave grabbed comic to default destination\n";
		$help .= "  -g         \tGrab new copy of all the comics\n";
		$help .= "  -l <string>\tLogin\n";
		$help .= "  -L         \tList available comics\n";
		$help .= "  -p <string>\tPassword\n";
		$help .= "  -u <string>\tphpGrabComics URL to connect\n";
		$help .= "  -U         \tSet phpGrabComics URL to localhost\n";
		$help .= "  -v         \tShow version\n";
		$help .= "  -V         \tVerbose\n";
		$help .= "  -h         \tThis help\n";
		
		echo $help;
	}
	
	// sets verbose level
	if($tmp = array_search("-V", $argv))
	{
		$verbose = True;
	}
	else
	$verbose = False;
	
	// sets username
	if($tmp = array_search("-l", $argv))
	{
		if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
		$user = $argv[$tmp+1];
		if($verbose)
		echo "\nUsername: $user";
	}
	
	// sets password
	if($tmp = array_search("-p", $argv))
	{
		if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
		$psw = $argv[$tmp+1];
		if($verbose)
		echo "\nPassword: $psw";
	}
	
	// sets phpgrabcomics site
	if($tmp = array_search("-U", $argv))
	{
		if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
		$url = $localhost_url;
		if($verbose)
		echo "\nUsing $url";
	}
	elseif($tmp = array_search("-u", $argv))
	{
		if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
		$url = $argv[$tmp+1];
		
		if(!preg_match("/.*\/$/",$url))
		$url = $url . "/";
		
		if($verbose)
		echo "\nUsing $url";
	}
	
	// sets last options
	$rss_url = $url . "phpgrabcomics.xml";
	
	if($tmp = array_search("-c", $argv))
	{
		if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
		{
			if($verbose)
			echo "\nGetting ". $argv[$tmp+1] . ".";
			
			$comic = $argv[$tmp+1];
			if($strip = @file_get_contents($url . "comic/" . $comic))
			{
				if($tmp = array_search("-f", $argv))
				{
					if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
					{
						if($verbose)
						echo "\nSaving to ". $argv[$tmp+1];
						
						$fp = @fopen($argv[$tmp+1],"wb");
						
						if($fp)
						{
							fwrite($fp,$strip);
							fclose($fp);
							
							echo " Done.";
						}
						else
						echo "\nCould not open $fp for writing.";
					}
				}
				elseif($tmp = array_search("-F", $argv))
				{
					if(isset($argv[$tmp+1]) and trim($argv[$tmp+1])!="")
					{
						$fp = @fopen($comic,"wb");
						
						if($fp)
						{
							fwrite($fp,$strip);
							fclose($fp);
							
							if($size=getimagesize($comic))
							{
								$mime = array(1 => "gif", 2 => "jpg", 3 => "png");
								
								$new_name = $comic.".".$mime[$size[2]];
								
								copy($comic,$new_name);
								unlink($comic);
								
								echo " Saved to $new_name.";
							}
						}
						else
						echo "\nCould not open $fp for writing.";
					}
				}
				else
				{
					echo $strip;
				}
			}
			else
			{
				echo "\nSorry, could not get the requested comic.";
				echo " Try checking if ". $url . "comic/" . $comic . " is a valid URL.";
			}
		}
	}
	
	// prints list of available comics
	if($tmp = array_search("-L", $argv))
	{
		echo "\nListing avaible comics:\n\n";
		
		if($fd=fopen($rss_url,"rt"))
		{
			while (!feof ($fd))
			{
				$buffer .= fgets($fd, 4096);
			}
			fclose ($fd);
		}
		
		preg_match_all("/<link>.*\/([^\/]*)<\/link>/i",$buffer,$matches);
		
		while(list($key,$val)=each($matches[1]))
		{
			if(strtolower($val)!="phpgrabcomics")
			{
				$comic_list[] = $val;
			}
		}
		
		sort($comic_list);
		
		while(list($key,$val)=each($comic_list))
		{
			echo $val. "\n";
		}
		echo "\n";
		
	}
	
	if($tmp = array_search("-g", $argv))
	{
		
		if($fd=fopen($rss_url,"rt"))
		{
			echo "\nConnecting to $url.\n";
			while (!feof ($fd))
			{
				$buffer .= fgets($fd, 4096);
			}
			fclose ($fd);
		}
		
		preg_match_all("/<link>.*\/([^\/]*)<\/link>/i",$buffer,$matches);
		
		while(list($key,$val)=each($matches[1]))
		{
			if(strtolower($val)!="phpgrabcomics")
			{
				$comic_list[] = $val;
			}
		}
		
		sort($comic_list);
		
		while (list($key,$val)=each($comic_list))
		{
			if(isset($user) and isset($psw) and $user!="" and $psw!="")
			$comic_url = $url . "index2.php?user=$user&psw=$psw&save=1&comic_array[]=" . $val;
			else
			$comic_url = $url . "index2.php?save=1&comic_array[]=" . $val;
			
			echo "\nDownloading ". $val;
			if($verbose)
				echo " (using $comic_url)";
			echo ".\n";
			
			if(version_compare(phpversion(),"4.3")>=0)
			{
				$buffer = file_get_contents($comic_url);
			}
			else
			{
				$fd = fopen ($comic_url, "r");
				if(isset($fd) and $fd!==False)
				{
					while (!feof ($fd)) {
						$buffer = fgets($fd, 4096);
					}
					fclose ($fd);
				}
				else
				{
					echo "Could not get ". $comic_url . "\n";
				}
			}
			
			if(!empty($buffer))
			echo trim(strip_tags($buffer))."\n";
		}
	}
	
	echo "\n";
}
?>
