<?php

class HTTP_PhpGrabComics_Request extends HTTP_Request {
	
	
	/**
	* Constructor
	*
	* Sets up the object
	* @param $url The url to fetch/access
	* @param $params Associative array of parameters which can be:
	*                  method         - Method to use, GET, POST etc
	*                  http           - HTTP Version to use, 1.0 or 1.1
	*                  user           - Basic Auth username
	*                  pass           - Basic Auth password
	*                  proxy_host     - Proxy server host
	*                  proxy_port     - Proxy server port
	*                  proxy_user     - Proxy auth username
	*                  proxy_pass     - Proxy auth password
	*                  timeout        - Connection timeout in seconds.
	*                  allowRedirects - Whether to follow redirects or not
	*                  maxRedirects   - Max number of redirects to follow
	*                  useBrackets    - Whether to append [] to array variable names
	*                  saveBody       - Whether to save response body in response object property
	* @access public
	*/
	function HTTP_PhpGrabComics_Request($url, $params = array())
	{
		$this->_sock           = &new Net_Socket();
		$this->_method         =  HTTP_REQUEST_METHOD_GET;
		$this->_http           =  HTTP_REQUEST_HTTP_VER_1_1;
		$this->_requestHeaders = array();
		$this->_postData       = null;
		
		$this->_user = null;
		$this->_pass = null;
		
		$this->_proxy_host = null;
		$this->_proxy_port = null;
		$this->_proxy_user = null;
		$this->_proxy_pass = null;
		
		$this->_allowRedirects = True;
		$this->_maxRedirects   = 4;
		$this->_redirects      = 0;
		
		$this->_timeout  = null;
		$this->_response = null;
		
		foreach ($params as $key => $value) {
			$this->{'_' . $key} = $value;
		}
		
		$this->setURL($url);
		
		// Make sure keepalives dont knobble us
		$this->addHeader('Connection', 'close');
	}
	
	
}
?>