<?php
/*

Copyright  2001, 2002, 2003, 2004 Andres Baravalle

This file is part of phpGrabComics.

phpGrabComics is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

phpGrabComics is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpGrabComics; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/**
 * admin class: contains static functions for admin and manteinance tasks.
 *
 * @author Andres Baravalle <andres@baravalle.it>
 *
*/
class admin
{
	
	/**
	* @return boolean
	* @desc analyses GET and decides which functions to call
	*/
	function checkFunc()
	{
		global $_GET;
		global $phpgrabcomics;
		global $static_copy;
		
		$tmp_return = True;
		
		if(isset($_GET["view"]) and $_GET["view"]==1)
		{
			for($a=0;$a<sizeof($phpgrabcomics);$a++)
			{
				echo "<p style=\"clear: left; margin-top: -4px\">".$phpgrabcomics[$a]->rIcon("view");
				echo "<strong>Today's " . $phpgrabcomics[$a]->name ." strip</strong>";
				echo "<span class=\"small\"> (visit the <a href=\"".$phpgrabcomics[$a]->address."\">web site</a>)</span></p>";
				
				if($static_copy==False and $phpgrabcomics[$a]->grab())
				{
					// dinamic: get the new copy
					echo "<p style=\"clear: left\"><a href=\"" . $phpgrabcomics[$a]->address . "\">";
					$phpgrabcomics[$a]->pGrabUrl();
					echo "</a></p>";
				}
				else
				{
					// gets the cached copy
					echo "<p style=\"clear: left\"><a href=\"" . $phpgrabcomics[$a]->address . "\">";
					$phpgrabcomics[$a]->pImg();
					echo "</a></p>";
				}				
			}
		}
		else if(isset($_GET["list_strips"]) and $_GET["list_strips"]==1)
		{
			printf(_LIST_STRIPS_TEXT);
			for($a=0;$a<sizeof($phpgrabcomics);$a++)
			{
				echo '<p style="clear: both; margin-top: 4px; padding-left: 20px;">';
				echo $phpgrabcomics[$a]->rIcon("view");
				echo '<strong>' . $phpgrabcomics[$a]->name .' archive</strong>';
				echo '</p>';
				echo '<div style="clear: both; padding-left: 20px; max-width: 80%; padding-bottom: 20px;">';
				$phpgrabcomics[$a]->pListComics();
				echo '</div>';		
			}
		}
		else if(isset($_GET["show_img"]) and $_GET["show_img"]!="")
		{
			echo "<p style=\"clear: left; margin-top: -4px\">";
			echo $phpgrabcomics[0]->rIcon();
			echo '<strong>' . $phpgrabcomics[0]->name .'</strong></p>';
			echo "<p style=\"clear: left\"><a href=\"" . $phpgrabcomics[0]->address . "\">";
			
			$img=$phpgrabcomics[0]->unix_name . "/". $_GET["show_img"];
			$phpgrabcomics[0]->pImg($img);
			
			echo "</a></p>";

		}
		else if(isset($_GET["save"]) and $_GET["save"]==1 and $GLOBALS["authenticated"] == True)
		{
			for($a=0;$a<sizeof($phpgrabcomics);$a++)
			{
				$phpgrabcomics[$a]->grab();
			}
		}
		else
		$tmp_return = False;
		
		return $tmp_return;
	}
	
	/**
	* @return boolean
	* @desc Very trivial function for user authentication
	*/
	function checkPerm()
	{
		global $_REQUEST;
		
		if ($GLOBALS["authenticated"] != True)
		{
			if (isset($_REQUEST["user"]) and isset($_REQUEST["psw"]) and $_REQUEST["user"] == $GLOBALS["user"] and md5($_REQUEST["psw"]) == $GLOBALS["psw"])
			{
				$GLOBALS["authenticated"] = True;
				$_SESSION["user"] = $_REQUEST["user"];
				$_SESSION["psw"] = $GLOBALS["psw"];
				
				return true;
			}
			elseif (isset($_SESSION["user"]) and isset($_SESSION["psw"]) and $_SESSION["user"] == $GLOBALS["user"] and $_SESSION["psw"] == $GLOBALS["psw"])
			{
				$GLOBALS["authenticated"] = True;
				return true;
			}
			elseif($GLOBALS["user"] == $GLOBALS["psw"] and !empty($GLOBALS["psw"]))
			{
				$GLOBALS["authenticated"] = True;
				return true;
			}
			else
			{
				$GLOBALS["authenticated"] = False;
				return false;
			}
		}
				
		return True;
	}
	
	/**
	* @return a url fragment
	* @param $max unknown
	* @desc returns the query string to be used in links leading back to home page
	*/
	function rQueryStringComicArray($comic_array)
	{
		$tmp_return = "";
		
		if (isset($comic_array) and !empty($comic_array))
		{
			for ($a=0;$a<sizeof($comic_array);$a++)
			{
				$tmp_return .= "comic_array[]=" . trim($comic_array[$a]);
				
				if (($a+1)<sizeof($comic_array))
				{
					$tmp_return .= "&amp;";
				}
			}
		}
		
		return $tmp_return;
	}
	
	function pComicListLink()
	{
		global $dir;
		
		$comic_array = func_get_args();
		
		$query_string = admin::rQueryStringComicArray($comic_array);
		 
		if(!empty($query_string))
		{
			$query_string = $dir . "index.php?view=1&amp;" . $query_string;	
		}
		else
			$query_string = $dir . "index.php?view=1";	
			
		echo $query_string;	
	}
	
	function pCustomDesktopLink($bg_color,$comic_array)
	{
		global $dir;
		
		$query_string = admin::rQueryStringComicArray($comic_array);
		
		if(!empty($query_string) and !empty($bg_color))
			$query_string .= "&amp;bg_color=" . urlencode($bg_color);
		elseif(!empty($bg_color))
			$query_string .= "bg_color=" . urlencode($bg_color);
		 
		if(!empty($query_string))
		{
			$query_string = $dir . "desktop.php?" . $query_string;	
		}
		else
			$query_string = $dir . "desktop.php";	
			
		echo $query_string;	
	}
	
	/**
	* @return void
	* @desc build a select menu for comics in the home page
	*/
	function MultipleSelectAllComics()
	{
		global $_SERVER;
		global $_GET;
		global $_REQUEST;
		global $comic_list;
		global $phpgrabcomics_selected;		
		?>
<form id="comic_form" method="get" action="<?php echo $_SERVER["SCRIPT_NAME"];?>" ondblclick="this.submit()" onsubmit="return checkSelectedComics();" style="padding: 4px">
	<fieldset>
		<legend style="background-color: <?php echo $GLOBALS["style"]; ?>">Select comic strips</legend>
		<p>
			<select name="comic_array[]" size="12" multiple="multiple" class="small" id="comic_array">
		<?php
		$a=0;
		
		do
		{
			$selected = "";
			
			$tmp=array_search($comic_list[$a]->unix_name, $phpgrabcomics_selected, true);
			if(is_int($tmp))
			{
				$selected = " selected=\"selected\"";
			}
			echo "\t\t\t\t\t<option value=\"" . $comic_list[$a]->unix_name. "\"$selected>". $comic_list[$a]->name ."</option>\n";
			$a++;
		}
		while ($a<sizeof($comic_list));
		
		?>
			</select>
			<label for="comic_array" class="small" style="clear: left">Use this menu to select today's strips that you want to view. Multiple selections are possible (up to 4).</label>
		</p>
		<?php

		if ($GLOBALS["authenticated"] == True and !isset($_GET["logout"]))
		{
			?>			
		<p>
			<input type="hidden" name="save" value="0" class="small" />
			<input type="button" value="save comics" onclick="document.forms[1].save.value=1;document.forms[1].view.value=0;document.forms[1].submit();" class="small_center" />
		</p>
			<?php
		}
		?>
		<p>
			<input type="hidden" name="view" value="1" />
			<input type="hidden" name="phpgrabcomics" value="<?php echo session_id(); ?>" />
			<input type="submit" value="view comics" class="small_center" />
		</p>
	</fieldset>
</form>
		<?php
	}
	
	/**
	* @return boolean
	* @param $key hits or credits
	* @desc updates hits or credits for showing comics
	*/
	function hitsAndCredits($key)
	{
		global $_SERVER;
		
		global $db_user;
		global $db_psw;
		global $db_host;
		global $db_name;
		global $db_prefix;
		global $comic_list;		
		global $db_enabled;
		
		if($db_enabled)
		{
			if(mysql_connect($db_host,$db_user,$db_psw) and mysql_select_db($db_name))
			{
				if(isset($_SERVER["HTTP_REFERER"]))
				{
					$tmp_page = parse_url($_SERVER["HTTP_REFERER"]);
					
					if(preg_match("/(.*)\/$/",$tmp_page["path"],$matches)==1)
					{
						$tmp_page["path"] = $matches[1];
					}
					
					if(strpos($tmp_page["host"],"www.")!==False)
					$tmp_page["host"]=str_replace("www.","",$tmp_page["host"]);
					
					$page = $tmp_page["host"] . $tmp_page["path"];
				}
				else
				$page = "test";
				
				$sql = "select * FROM ${db_prefix}_sites where page = '$page';";
				
				$result = mysql_query($sql);
				
				if($result and mysql_num_rows($result)>0)
				{
					// update the number
					$row = mysql_fetch_array($result, MYSQL_ASSOC);
					$val = $row[$key] + 1;
					
					$sql = "update ${db_prefix}_sites set $key = $val where page = '$page'";
				}
				elseif($result)
				{
					$sql = "insert into ${db_prefix}_sites (page,hits,credits,approved) values (
    '$page', '1', '0', '0')";
				}
				else
				{
					// there is some error in db configuration
					// just proceed
					return True;
				}
				
				$result = mysql_query($sql);
				
				// update counter of requested comics
				if($key=="hits")
				{
					// checking for the old way of getting comics in desktop.html
					if(isset($_SERVER["PATH_INFO"]))
						$comic = trim(substr($_SERVER["PATH_INFO"],1));
					elseif(isset($GLOBALS["phpgrabcomics_selected"]))
						$comic = $GLOBALS["phpgrabcomics_selected"][0];
					else
						$comic = $GLOBALS["default_comic"];

					
					if($comic!="" and admin::rStripIndex($comic) !== False)
					{
						
						$sql = "select hits FROM ${db_prefix}_hits where comic = '$comic'";
						$result2 = mysql_query($sql);
						
						if(mysql_num_rows($result2)>0)
						{
							$row = mysql_fetch_array($result2, MYSQL_ASSOC);
							$val = $row["hits"] + 1;
							$sql = "update ${db_prefix}_hits set hits = $val, last_date = now() where comic = '$comic'";
						}
						else
						{
							$sql = "insert into ${db_prefix}_hits (comic,hits,date,last_date) values ('$comic', '1', now(), now())";
						}
						
						$result2 = mysql_query($sql);
					}
				}
				
				
				if($result)
				return True;
				else
				return False;
			}
		}
		else
		return True;
	}
	
	/**
	* @return boolean
	* @desc checks if a user can download an image or not. if the user did not expose the banner, his users cannot download comics.
	*/
	function checkLink()
	{
		global $_SERVER;
		
		global $db_user;
		global $db_psw;
		global $db_host;
		global $db_name;
		global $db_prefix;
		global $db_enabled;
		
		if($db_enabled===True)
		{
			$tmp_return = False;
			
			// when connecting the system checks if you have a token
			// and you can proceed getting the image
			// you get your token by:
			// -exposing phpgrabcomics logo in the page: when the logo is loaded, you get a token for 24 hours
			// -having an appropriate exposures vs request ratio (I ask for 1 logo exposure every 8 requests)
			// -having your page "approved" (contact the autor)
			
			if(mysql_connect($db_host,$db_user,$db_psw) and mysql_select_db($db_name))
			{
				if(isset($_SERVER["HTTP_REFERER"]))
				{
					$tmp_page = parse_url($_SERVER["HTTP_REFERER"]);
					
					if(preg_match("/(.*)\/$/",$tmp_page["path"],$matches)==1)
					{
						$tmp_page["path"] = $matches[1];
					}
					
					if(strpos($tmp_page["host"],"www.")!==False)
					$tmp_page["host"]=str_replace("www.","",$tmp_page["host"]);
					
					$page = $tmp_page["host"] . $tmp_page["path"];
					
					$sql = "select * FROM ${db_prefix}_sites where page = '$page';";
					
					$result = mysql_query($sql);
					
					// checks if there have already been requests from the host
					if(mysql_num_rows($result)>0)
					{
						$row = mysql_fetch_array($result, MYSQL_ASSOC);
						
						if(trim($row["approved"])==1)
						{
							$tmp_return = True;
						}
						else if($row["banned"]==1)
						{
							$tmp_return = False;
						}
						elseif($row["hits"]<8)
						{
							// give some free tests: for the first hits no banner need to be exposed.
							// should help testing.
							$tmp_return = True;
						}
						else if($row["credits"]>0)
						{
							// check the exposure/request ratio
							
							$ratio = $row["hits"]/$row["credits"];
							
							// if exposure/request < 8, output the comic
							if($ratio<8)
							{
								$tmp_return = True;
							}
						}
						
					}
					else
					{
						// the db is not working or
						// there is still no row for the site in the db
						// could be running this function before hitsAndCredits 
						// and so there would be no line at all in the db.
						$tmp_return = True;
					}
					
					if((strpos($page,"desktop.htm") or strpos($page,"desktop.php") or strpos($page,"getcomics")) and $row["banned"]!=1)
					$tmp_return = True;
					
					// if there is no record, it means that there is no banner exposure
					// so return false
					
					@mysql_free_result($result);
					@mysql_close($link);
				}
				else
				{
					// HTTP_REFERER is not set; will return true
					$tmp_return = True;
				}
			}
			
		}
		else
		{
			// database is not enabled; ; will return true
			$tmp_return = True;
		}
		
		return $tmp_return;
		
	}
	
	/**
	* @return boolean
	* @param $data data to be printed in a table
	* @param $cols number of columns
	* @desc prints a table based on data and of $cols columns
	*/
	function pTable($data,$cols)
	{
		if(empty($data) or empty($cols) or !is_array($data))
		{
			return Array();
		}
		else
		{
			$c = 1;
			
			echo "<table>";
			
			while(list($key,$val) = each($data))
			{
				// when c == 0 make a row
				if($c==1)
				echo "<tr>\n";
				
				echo "<td style=\"text-align: center\">$val</td>\n";
				
				$c++;
				
				// when c == cols close a row
				if($c>$cols)
				{
					echo "</tr>\n";
					$c = 1;
				}
			}
			
			if($c<$cols)
			{
				while($c<=$cols)
				{
					echo "<td>&nbsp;</td>\n";
					
					$c++;
				}
				
				echo "</tr>\n";
			}
			
			echo "</table>";
		}
	}
	
	/**
	* @return True or dies
	* @desc includes all the comics, even the ones not passed through GET.	
 	*/
	function includeComics()
	{
		global $comic_list;
		global $dir;
		
		if ($handle=opendir($dir . $GLOBALS["config"]))
		{
			while ($tmp = readdir($handle))
			{
				if (strpos($tmp,".inc")!=False)
				{
					$tmp_file[] = $tmp;
				}
			}
			
			closedir($handle);
			sort($tmp_file);
			
			for($pos=0,$pos2=0;$pos<sizeof($tmp_file);$pos++)
			{
				if(preg_match("/(.*)\.inc$/",$tmp_file[$pos],$matches))
				{
					
					// some files have been included in upper cicle.
					include_once($dir . $GLOBALS["config"] . "/" . $tmp_file[$pos]);
					
					$tmp = $matches[1];
					
					$comic_class=strtoupper(substr($tmp,0,1)).substr($tmp,1);
					
					$comic_list[$pos2]=new $comic_class();
					
					if(empty($comic_list[$pos2]->name))
					$comic_list[$pos2]->name = $comic_class;
					
					if(empty($comic_list[$pos2]->unix_name))
					$comic_list[$pos2]->unix_name = $tmp;
					
					$pos2++;
				}
			}
		}
		
		usort($comic_list,array("phpgrabcomics", "sort"));
		
		if(empty($comic_list))
		die("Could not include comics.");
		else
		return True;
	}
	
	/**
	* @return the index of the comic in the global array of comics or false
	* @param $comic unixname of the comic
 	*/
	function rStripIndex($comic)
	{
		global $comic_list;
				
		if(empty($comic_list))
			trigger_error(_COMICS_NOT_INCLUDED,E_USER_WARNING );	
		else
		{	
			for($a=0;$a<sizeof($comic_list);$a++)
			{
					if($comic_list[$a]->unix_name==$comic)
					{
						return $a;			
					}
			}
		}
		return False;		
	}
	
	/**
	* @return the name of the comic given its unixname
	* @param $comic unixname of the comic
 	*/
	function rStripName($comic)
	{
		global $comic_list;
				
		if(empty($comic_list))
			trigger_error(_COMICS_NOT_INCLUDED,E_USER_WARNING );	
		else
		{	
			$index = admin::rStripIndex($comic);
			if($index !== False and !empty($comic_list[$index]->name))
			{
				return $comic_list[$index]->name;
			}
		}
		return False;		
	}
	
	function appFiles($matches,$absolute = False,$directory_separator)
	{
		global $dir;	
		$recurse = True;
		$files = "";	
		
		// you can provide to the function a directory separator.
		// if you do not provide it, the system default will be used.
		if(!isset($directory_separator))
			$directory_separator = DIRECTORY_SEPARATOR;
		
		while(list($key,$val) = each($matches))
		{
			if(is_array($val))
			{
				$match = $val[0];			
				if($val[1] === False)
					$recurse = False;
			}
			else
				$match = $val;
			
			$files .= admin::browsePath($match,$recurse,$directory_separator);
		}
		
		if(strlen($files)>0)
		{
			$files_array = explode("\n",trim($files));
			
			if(is_array($files_array) and !empty($files_array))
			{
				natsort($files_array);
				
				$a=1;
				
				while(list($key,$val) = each($files_array))
				{
					if($absolute===False)
						echo $val . "\n";
					else
						echo realpath($val) ."\n";
						
					$a++;
				}
			}
			else
				trigger_error ("Sorry, array of files empty.", E_USER_ERROR);
		}
		else
			trigger_error ("Sorry, no files found.", E_USER_ERROR);
	}
	
	/**
	* @return list of files
	* @param $path path in the filesystem
	* @param $recurse if need to check the subfolders or not
	* @desc browses $path and returns the name of files.	
 	*/
	function browsePath($path,$recurse = True,$directory_separator)
	{
			// you can provide to the function a directory separator.
			// if you do not provide it, the system default will be used.
			if(!isset($directory_separator))
				$directory_separator = DIRECTORY_SEPARATOR;
				
			$files = "";
			
			if(is_dir($path))
			{
				$d = dir($path);
				
				while (false !== ($entry = $d->read())) 
				{
					if($entry != "." and $entry != "..")
					{
						if(!is_dir($path . $directory_separator . $entry) or $recurse === True)
							$files .= admin::browsePath($path . $directory_separator . $entry,$recurse,$directory_separator);
					}									
				}
		
				$d->close();					
								
				if(empty($files))
				{
					// if a directory is empty, add the name
					$files .= $path . "\n";
				}
			}
			elseif(is_file($path))
			{
				if($GLOBALS["private_exclude"] === False or !admin::isPrivate($path))
				{
					if(substr($path,0,2)==".".$directory_separator)
					{
						// strips "./" from the beginning of the string
						$path=substr($path,2);
					}
					$files .= $path . "\n";
				}
			}		
			
			return $files;
	}


	/**
	* @return boolean
	* @param $path path in the filesystem
	* @desc checks if a given path is contained in the list of private files
	* private files are not to be included in authomatic backups.	
 	*/
	function isPrivate($path)
	{
		reset($GLOBALS["private_files"]);
		
		while(list($key,$val) = each($GLOBALS["private_files"]))
		{
			if(strpos($path,$val)!==False)
				return True;		
		}			
		return False;
	}
}
?>
