<?php
/*

Copyright  2001, 2002, 2003, 2004 Andres Baravalle

This file is part of phpGrabComics.

phpGrabComics is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

phpGrabComics is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpGrabComics; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
* this file is included by all the pages of phpGrabComics: sets all basic configuration and includes all the common files.
*/

// last cehck to see if dir is set
// shoukd be set by dir.inc, or in the file including prepend.inc
if(!isset($dir))
$dir = "./";

// the web path of the current directory
$web_dir = dirname($_SERVER["SCRIPT_NAME"]);

// the web path, including domain and port, of the current directory
$full_web_dir = "http://". $_SERVER["SERVER_NAME"]. ":". $_SERVER["SERVER_PORT"] .$web_dir;  

// setting php environment
ini_set("arg_separator.input","&");
ini_set("arg_separator.output","&amp;");
ini_set("display_errors","1");
ini_set("error_reporting","2047");
ini_set("magic_quotes_gpc","1");
ini_set("max_execution_time","120");
ini_set("register_globals","0");
ini_set("session.use_cookies","1");
ini_set("session.use_trans_sid","0");
ini_set("short_open_tag","0");
ini_set("track_vars","1");
ini_set("max_execution_time", "1800");

umask(0);

// starting session
if(!isset($cache_limiter))
{
	session_cache_limiter("private");
}
session_name("phpgrabcomics");
session_start();

// include phpgrabcomics configuration
include_once($dir . "inc/config.inc");
include_once($dir . "inc/admin.inc");
include_once($dir . "inc/phpgrabcomics.inc");
include_once($dir . "inc/lang_english.inc");

// include PEAR classes
include_once($dir . "inc/PEAR.php");
include_once($dir . "inc/Net/Socket.php");
include_once($dir . "inc/Net/URL.php");
include_once($dir . "inc/HTTP/Request.php");
include_once($dir . "inc/HTTP/PhpGrabComics_Request.php");

// deciding if the page will be compressed or not
if($gzip === True and isset($_SERVER["HTTP_ACCEPT_ENCODING"]) and strpos($_SERVER["HTTP_ACCEPT_ENCODING"],"gzip")!==False and strpos($_SERVER["PHP_SELF"],"php")!==False)
{
	ob_start();
	ob_implicit_flush(0);
}

if(!is_dir($comics))
mkdir($comics,"0777");

$admin = new admin();
$phpgrabcomics = Array();

// will contain the unix_name of selected comics:
// -values of $_GET["comic_array"]
// -other values
// can contain values before this point
// (e.g. comic.php sets phpgrabcomics_selected and includes prepend.inc only later)
if(!isset($phpgrabcomics_selected))
$phpgrabcomics_selected = Array();

if(isset($_GET["comic_array"]) and is_array($_GET["comic_array"]) and !empty($_GET["comic_array"]))
{
	$phpgrabcomics_selected = array_merge($_GET["comic_array"],$phpgrabcomics_selected);
}

// phpgrabcomics_selected is used in comic.php 
if(!empty($phpgrabcomics_selected))
{
	sort($phpgrabcomics_selected);
	while (list($key,$val) = each($phpgrabcomics_selected))
	{
		// include requested comics
		$page = $dir . $config . "/" . $val.".inc";
		
		if (file_exists($page) and !empty($val))
		{
			include_once($page);
			$pos = sizeof($phpgrabcomics);
			
			$comic_class=strtoupper(substr($val,0,1)).substr($val,1);
			$phpgrabcomics[$pos]=new $comic_class();			
			
			if(empty($phpgrabcomics[$pos]->name))
			$phpgrabcomics[$pos]->name = $comic_class;
			
			if(empty($phpgrabcomics[$pos]->unix_name))
			$phpgrabcomics[$pos]->unix_name = $val;
		}
	}
}

// need to check if comics have been added. maybe someone can try to get a non existent comic
// in that case you have to get default comic
// there is a bug in following lines that I cannot find

if(empty($phpgrabcomics))
{
	$page = $dir . $config . "/" . $default_comic . ".inc";
	
	if (file_exists($page))
	{
		include_once($page);
		$comic_class=strtoupper(substr($default_comic,0,1)).substr($default_comic,1);
		$phpgrabcomics[]=new $comic_class();
		$phpgrabcomics_selected[]=$default_comic; 
	}
	else
	die();
}

// saves in $comic_list an array of objects similat to $phpgrabcomics, but including all the comics
admin::includeComics();

// checks if including file is the homepage
if(basename($_SERVER["SCRIPT_NAME"])=="index.php" and $dir=="./")
{
	if(isset($_GET["show"]) and $_GET["show"]==1)
	{
		if($static_copy==False)
		{
			// gets a new copy copy
			$phpgrabcomics[0]->grab();
		}
		
		if(!admin::hitsAndCredits("hits"))
		{
			$path = "media/phpgrabcomics_error.png";
			$phpgrabcomics[0]->makeImg($path);
		}
		else
		{
			if(admin::checkLink())
			$phpgrabcomics[0]->makeImg();
			else
			$phpgrabcomics[0]->makeImg("media/phpgrabcomics_no_banner.png");
		}
		
		die();
	}
	// includes all the comics
	else
	{
		admin::checkPerm();
	}
}
?>